<?php
  /**
   * @file
   * KerberosInterface class definition.
   */
  class KerberosInterface {
    private $realm; //Realm Name
    private $credential_cache;

    function __construct($realm_name) {
      $this->realm = $realm_name;
    }

    /**
     * @param string $username username
     * @param string $password password
     * @return array -- tickets
     */
    function getTicket($username, $password) {
      $this->credential_cache = new KRB5CCache(); //init
      $this->credential_cache->setConfig('/etc/krb5.conf'); //default config for kerberos
      $principle = $username . '@' . $this->realm; //Construct principle from username and realm
      try {
        $this->credential_cache->initPassword($principle, $password);
      } catch ( Exception $e ) {
      }
      $entries = $this->credential_cache->getEntries(); //returns the same as running `klist`
      if (empty( $entries )) { //If there's no ticket at position 0, there are no tickets!
        return FALSE;
      }
      else {
        return $entries;
      }
    }

    function setRealm($realm) {
      $this->realm = $realm;
    }

    function getRealm() {
      return $this->realm;
    }
  }